#include "MQBasePlugin.h"

// CNX
class BevelMultiFace : public MQSelectPlugin
{
public:
	BevelMultiFace();
	virtual ~BevelMultiFace();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

	class PointMap
	{
	public:
		PointMap(cmq::flindex_t key, const MQPoint &p, cmq::vindex_t vindex = -1) : m_key(key), m_vindex(vindex) {m_p.push_back(p);}
		cmq::flindex_t m_key; // IWi_nԖڃVtg̒_L[(flindex_tőp)
		cmq::vindex_t m_vindex;
		std::vector<MQPoint> m_p;
		cmq::flindex_t hash() const {return m_key;}
	};

	class OrderFace
	{
	public:
		OrderFace(const std::vector<cmq::flindex_t> &point, cmq::findex_t orig = -1) : m_point(point), m_orig(orig), m_neighbor_line(-1), m_exist(false) {}
		std::vector<cmq::flindex_t> m_point;
		cmq::findex_t m_orig;
		cmq::flindex_t m_neighbor_line;
		bool m_exist;
	};

	BOOL main();
private:
	float m_offset;
	float m_inset;
	int m_times;
	int m_mode;
	bool m_backface;

	int posX;
	int posY;

	cmq::CMQDocument doc;

	BOOL callDialog();
	void loadSetting();
	void saveSetting();

	void extudeface(cmq::CMQObject &obj, std::set<cmq::findex_t> &faces, std::unordered_multimap<cmq::findex_t, int> &outline, std::unordered_map<cmq::flindex_t, PointMap> &vertlist, std::vector<OrderFace> &orderface);
	void makesideface(cmq::CMQObject &obj, std::unordered_multimap<cmq::findex_t, int> &outline, std::unordered_map<cmq::flindex_t, PointMap> &vertlist, std::vector<OrderFace> &orderface);
	void makeVertexes(cmq::CMQObject &obj, std::unordered_map<cmq::flindex_t, PointMap> &vertlist);
	void makeFaces(cmq::CMQObject &obj, std::unordered_map<cmq::flindex_t, PointMap> &vertlist, std::vector<OrderFace> &orderface);
};

class BevelMultiFaceDialog : public MQDialog
{
public:
	BevelMultiFaceDialog(MQWindowBase& parent, BevelMultiFace *plugin);
	~BevelMultiFaceDialog() {}

	BevelMultiFace *m_pPlugin;

private:
	MQDoubleSpinBox *m_offset;
	MQDoubleSpinBox *m_inset;
	MQSpinBox *m_times;
	MQCheckBox *m_backface;

	MQRadioButton *m_radio[3];

	BOOL radioevent(MQWidgetBase *sender, MQDocument doc);
	BOOL keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param);

	friend class BevelMultiFace;
};
